<div id="body" class="container-fluid">
  <div class="row">
    <div class="col-24">
      <h6 class="mb-3">Federal Reserve Event</h6>
      <h6 class="text-danger" *ngIf="isLocked">This event is currently locked by {{ lockedByUser }}</h6>
      <form [formGroup]="form" novalidate>
        <div class="form-row text-center">
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4 offset-md-6 offset-lg-8">
            <button type="button" class="btn btn-sm btn-secondary btn-block" (click)="cancel()">
              Cancel
            </button>
          </div>
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4" *ngIf="!isLocked && allowEdit">
            <div *ngIf="editMode; then saveTemplate; else editTemplate;"></div>
            <ng-template #editTemplate>
              <button type="button" class="btn btn-sm btn-primary btn-block" (click)="edit()">
                Edit Event
              </button>
            </ng-template>
            <ng-template #saveTemplate>
              <button type="button" class="btn btn-sm btn-primary btn-block" (click)="save()" [disabled]="form.invalid">
                Save
              </button>
            </ng-template>
          </div>
        </div>
        <br />
        <fieldset>
          <div class="form-row">
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col-24 col-lg-4">Event ID: </label>
              <div class="col-24 col-lg-20 pl-0 pl-lg-3">
                <input type="text" class="form-control form-control-sm" formControlName="eventID" />
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row col-lg-24">
              <label class="col-form-label col-24 col-lg-4">
                Event Status
              : </label>
              <div class="col-24 col-lg-20 pl-0 pl-lg-3">
                <input type="text" class="form-control form-control-sm" formControlName="eventStatus" />
              </div>
            </div>
          </div>
          <div class="form-row">
            <div *ngIf="isDisconnect" class="form-group form-group-sm row col-24 col-lg-12">
              <label class="col-form-label col-24 col-lg-8">Is Activity Due To Move?</label>
              <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                <input type="text" class="form-control form-control-sm" formControlName="activityDueToMove" />
              </div>
            </div>
            <div class="form-group form-group-sm row col-24 col-lg-12">
              <label class="col-form-label col-24 col-lg-8">Event Title: </label>
              <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                <input type="text" class="form-control form-control-sm" formControlName="eventTitle" />
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row col-24 col-lg-12">
              <label class="col-form-label col-24 col-lg-8">Customer Name: </label>
              <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                <div class="input-group">
                  <input type="text" class="form-control form-control-sm" formControlName="custName" />
                </div>
              </div>
            </div>
            <div class="form-group form-group-sm row col-24 col-lg-12">
              <label class="col-form-label col-24 col-lg-8">Org ID: </label>
              <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                <input type="text" class="form-control form-control-sm" formControlName="custOrgID" />
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row col-24 col-lg-12">
              <label class="col-form-label col-24 col-lg-8">MDS Event Type: </label>
              <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                <input type="text" class="form-control form-control-sm" formControlName="mdsEventType" />
              </div>
            </div>
            <div class="form-group form-group-sm row col-24 col-lg-12">
              <label class="col-form-label col-24 col-lg-8">MDS Activity Type: </label>
              <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                <input type="text" class="form-control form-control-sm" formControlName="mdsActivityType" />
                <!--<dx-select-box [items]="activityTypeList" formControlName="mdsActivityType"
        displayExpr="description" valueExpr="value"></dx-select-box>-->
              </div>
            </div>
          </div>
          <br />
          <div class="card mb-3">
            <mat-accordion>
              <mat-expansion-panel [expanded]="true" class="card">
                <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                  <mat-panel-title><h6>Managed Device Table</h6></mat-panel-title>
                </mat-expansion-panel-header>
                <div class="mb-3">
                  <table class="table" style="border: 1px solid #ddd;">
                    <thead>
                      <tr>
                        <th>FRB Request ID</th>
                        <th *ngIf="isInstallorHeadend">Migration Type</th>
                        <th *ngIf="isInstallorHeadend">Order Type</th>
                        <th *ngIf="isInstallorHeadend">Reason for Reorder/Replacement</th>
                        <th *ngIf="isInstallorHeadend">Expedite?</th>
                        <th>FRB Order Submission Date</th>
                        <th>Device Name</th>
                        <th>Serial Number</th>
                        <th *ngIf="isInstallorHeadend">Model</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr>
                        <td>{{frbRequestId}}</td>
                        <td *ngIf="isInstallorHeadend">{{installType}}</td>
                        <td *ngIf="isInstallorHeadend">{{orderSubType}}</td>
                        <td *ngIf="isInstallorHeadend">{{reorderReason}}</td>
                        <td *ngIf="isInstallorHeadend">{{isExpedite ? 'Yes' : 'No'}}</td>
                        <td>{{frbSentDate | date}}</td>
                        <td>{{deviceName}}</td>
                        <td>{{serialNum}}</td>
                        <td *ngIf="isInstallorHeadend">{{model}}</td>
                      </tr>
                    </tbody>
                  </table>
                </div>
              </mat-expansion-panel>
            </mat-accordion>
          </div>

          <div *ngIf="origReqId != 0 && origReqId != null" class="card mb-3">
            <mat-accordion>
              <mat-expansion-panel [expanded]="true">
                <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                  <mat-panel-title><h6>Original Device Info</h6></mat-panel-title>
                </mat-expansion-panel-header>
                <div class="mb-3">
                  <table class="table" style="border: 1px solid #ddd;">
                    <thead>
                      <tr>
                        <th>Original Request ID</th>
                        <th>Device Name</th>
                        <th>Serial Number</th>
                        <th>Model</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr>
                        <td>{{origReqId}}</td>
                        <td>{{origDeviceName}}</td>
                        <td>{{origSerialNum}}</td>
                        <td>{{origModel}}</td>
                      </tr>
                    </tbody>
                  </table>
                  <!--<dx-data-grid #grid id="grid" [dataSource]="origDeviceDataList" [wordWrapEnabled]="true"
                        [rowAlternationEnabled]="true" [showBorders]="true" [columnAutoWidth]="true">
            <dxo-export [enabled]="true" fileName="Events"></dxo-export>
            <dxo-paging [pageSize]="50"></dxo-paging>
            <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]"></dxo-pager>
            <dxo-search-panel [visible]="true" [highlightCaseSensitive]="true"></dxo-search-panel>
            <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
          </dx-data-grid>-->
                </div>
              </mat-expansion-panel>
            </mat-accordion>
          </div>

          <div *ngIf="isInstallorHeadend || isHeadend" class="card mb-3">
            <mat-accordion>
              <mat-expansion-panel [expanded]="true" class="card">
                <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                  <mat-panel-title><h6>Site Location Information</h6></mat-panel-title>
                </mat-expansion-panel-header>
                <div class="card-body">
                  <h6>INSTALLATION</h6>
                  <div formGroupName="installation">
                    <div class="form-row">
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Site Address 1: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="siteAddress1" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Install Site POC: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="primaryPOCName" />
                        </div>
                      </div>
                    </div>
                    <div class="form-row">
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Site Address 2: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="siteAddress2" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Install Site POC Phone: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="primaryPOCPhone" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Extension: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="primaryPOCPhoneExtension" />
                        </div>
                      </div>
                    </div>
                    <div class="form-row">
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">City: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="city" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Install Site POC Email: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="primaryPOCEmail" />
                        </div>
                      </div>
                    </div>
                    <div class="form-row">
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">State/Province: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="stateProv" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Back-up Install Site POC: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="secondaryPOCName" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Country: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="country" />
                        </div>
                      </div>
                    </div>
                    <div class="form-row">
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Back-up Install Site POC Phone: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="secondaryPOCPhone" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Extension: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="secondaryPOCPhoneExtension" />
                        </div>
                      </div>
                    </div>
                    <div class="form-row">
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Zip/Postal Codes: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="zip" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Back-up Install Site POC Email: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="secondaryPOCEmail" />
                        </div>
                      </div>
                    </div>
                  </div>
                </div>

                <div class="card-body">
                  <h6>SHIPPING</h6>
                  <div formGroupName="shipping">
                    <div class="form-row">
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Shipping Address 1: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="siteAddress1" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Shipping Site POC: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="primaryPOCName" />
                        </div>
                      </div>
                    </div>
                    <div class="form-row">
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Shipping Address 2: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="siteAddress2" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Shipping Site POC Phone: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="primaryPOCPhone" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Extension: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="primaryPOCPhoneExtension" />
                        </div>
                      </div>
                    </div>
                    <div class="form-row">
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">City: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="city" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Shipping Site POC Email: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="primaryPOCEmail" />
                        </div>
                      </div>
                    </div>
                    <div class="form-row">
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">State/Province: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="stateProv" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Country: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="country" />
                        </div>
                      </div>
                    </div>
                    <div class="form-row">
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Zip/Postal Codes: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="zip" />
                        </div>
                      </div>
                      <div class="form-group form-group-sm row col-24 col-lg-12">
                        <label class="col-form-label col-24 col-lg-8">Configuration Type: </label>
                        <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                          <input type="text" class="form-control form-control-sm" formControlName="designDisplay" />
                        </div>
                      </div>
                    </div>
                  </div>
                </div>

                <div class="card-body">
                  <h6>CONFIGURATION DATA</h6>
                  <div class="card-body">
                    <div class="form-row">
                      <h6>WAN IP Information</h6>
                      <table class="table" style="border: 1px solid #ddd;">
                        <thead>
                          <tr>
                            <th>WAN Port #</th>
                            <th>WAN IP Address</th>
                            <th>WAN IP Subnet Mask</th>
                            <th>WAN Default Gateway</th>
                            <th>WAN Speed</th>
                            <th>WAN Duplex</th>
                            <th>Gateway MAC Address (optional)</th>
                          </tr>
                        </thead>
                        <tbody>
                          <tr>
                            <td>{{portName}}</td>
                            <td>{{ipAddress}}</td>
                            <td>{{subnetMask}}</td>
                            <td>{{defaultGateway}}</td>
                            <td>{{speed}}</td>
                            <td>{{duplex}}</td>
                            <td>{{macAddress}}</td>
                          </tr>
                        </tbody>
                      </table>
                    </div>

                    <div class="form-row">
                      <div class="mb-3">
                        <h6>LAN IP Information</h6>
                        <table class="table" style="border: 1px solid #ddd;">
                          <thead>
                            <tr>
                              <th>LAN IP Address</th>
                              <th>LAN IP Subnet Mask</th>
                              <th *ngIf="designType == '3' || designType =='C'">LAN Speed</th>
                              <th *ngIf="designType == '3' || designType =='C'">LAN Duplex</th>
                            </tr>
                          </thead>
                          <tbody>
                            <tr>
                              <td>{{lanIpAddress}}</td>
                              <td>{{lanSubnetMask}}</td>
                              <td *ngIf="designType == '3' || designType =='C'">{{lanSpeed}}</td>
                              <td *ngIf="designType == '3' || designType =='C'">{{lanDuplex}}</td>
                            </tr>
                          </tbody>
                        </table>
                      </div>
                    </div>
                    <div class="form-row">
                      <h6>Subscriber/Network</h6>
                      <div class="mb-3" *ngIf="designType == '1'">
                        <dx-data-grid #grid id="grid" [dataSource]="subscriberConfigsList" [wordWrapEnabled]="true"
                                      [rowAlternationEnabled]="true" [showBorders]="true" [columnAutoWidth]="true">
                          <dxo-sorting mode="multiple"></dxo-sorting>
                          <dxo-paging [pageSize]="50"></dxo-paging>
                          <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]"></dxo-pager>
                          <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
                          <dxi-column dataField="portName" caption="Port #" dataType="string"></dxi-column>
                          <dxi-column dataField="ipAddress" caption="IP Address" dataType="string"></dxi-column>
                          <dxi-column dataField="speed" caption="Subscriber Speed" dataType="string"></dxi-column>
                          <dxi-column dataField="duplex" caption="Subscriber Duplex" dataType="string"></dxi-column>
                        </dx-data-grid>
                      </div>
                      <div class="mb-3" *ngIf="designType != '1'">
                        <dx-data-grid #grid id="grid" [dataSource]="subscriberConfigsList" [wordWrapEnabled]="true"
                                      [rowAlternationEnabled]="true" [showBorders]="true" [columnAutoWidth]="true">
                          <dxo-sorting mode="multiple"></dxo-sorting>
                          <dxo-paging [pageSize]="50"></dxo-paging>
                          <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]"></dxo-pager>
                          <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
                          <dxi-column dataField="ipAddress" caption="IP Address" dataType="string"></dxi-column>
                          <dxi-column dataField="subnetMask" caption="IP Subnet Mask (optional)" dataType="string"></dxi-column>
                          <dxi-column dataField="defaultGateway" caption="Gateway IP Address (optional)" dataType="string"></dxi-column>
                          <dxi-column dataField="macAddress" caption="Gateway MAC Address (optional)" dataType="string"></dxi-column>
                        </dx-data-grid>
                      </div>
                    </div>
                  </div>
                </div>
              </mat-expansion-panel>
            </mat-accordion>
          </div>

          <div class="card mb-3">
            <mat-accordion>
              <mat-expansion-panel [expanded]="true">
                <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                  <mat-panel-title><h6>Manual Data</h6></mat-panel-title>
                </mat-expansion-panel-header>
                <div formGroupName="manualData">
                  <div class="form-row">
                    <div class="form-group form-group-sm row col-24 col-lg-24 col-xxl-12">
                      <label class="col-form-label col-24 col-lg-4 col-xxl-8">Completed Email CC: </label>
                      <div class="col-24 col-lg-20 col-xl-12 col-12 col-xxl-16 pl-0 pl-lg-3">
                        <div class="input-group">
                          <input type="text" class="form-control form-control-sm" formControlName="completeEmailCC" />
                          <app-user-finder *ngIf="option.manualData.userFinderForCompleteEmail?.isEnabled" id="complete-email" [group]="form.controls.manualData" [option]="option.manualData.userFinderForCompleteEmail"></app-user-finder>
                        </div>
                      </div>
                    </div>
                    <div class="form-group form-group-sm row col-24">
                      <label class="col-form-label col-24 col-lg-4">Event Comments: </label>
                      <div class="col-24 col-lg-20 pl-0 pl-lg-3">
                        <textarea class="form-control form-control-sm" formControlName="comments" rows="5"></textarea>
                      </div>
                    </div>
                  </div>
                  <hr>
                  <div class="form-row">
                    <div class="form-group form-group-sm row col-24 col-lg-12">
                      <label class="col-form-label col-24 col-lg-8">Workflow Status: </label>
                      <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                        <dx-select-box [items]="workflowStatusList"
                                       displayExpr="endEventStus.eventStusDes"
                                       valueExpr="endEventStus.eventStusId"
                                       placeholder="Workflow Status"
                                       (onValueChanged)="workflowStatusChanged($event.value)"
                                       formControlName="workflowStatus"></dx-select-box>
                      </div>
                    </div>
                    <div class="form-group form-group-sm row col-24 col-lg-12" *ngIf="getFormControlValue('manualData.workflowStatus') == 3">
                      <label class="col-form-label col-24 col-lg-8">Pre-Stage Fail Codes: </label>
                      <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                        <dx-select-box [items]="preConfigFailCodesList"
                                       displayExpr="failCdDes"
                                       valueExpr="failCdId"
                                       (onValueChanged)="getPreStageFailCode($event)"
                                       formControlName="preStageFailCodes"></dx-select-box>
                        <input type="hidden" class="form-control form-control-sm" formControlName="hdnPreStageFailCodes" />
                      </div>
                    </div>
                  </div>
                  <div *ngIf="!isHeadend" class="form-row">
                    <div class="form-group form-group-sm row col-24 col-lg-12">
                      <label class="col-form-label col-24 col-lg-8">Shipping Carrier: </label>
                      <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                        <input type="text" class="form-control form-control-sm" formControlName="shippingCarrier" />
                      </div>
                    </div>
                    <div class="form-group form-group-sm row col-24 col-lg-12">
                      <label class="col-form-label col-24 col-lg-8">Tracking Number: </label>
                      <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                        <input type="text" class="form-control form-control-sm" formControlName="trackingNumber" />
                      </div>
                    </div>
                  </div>
                  <div *ngIf="!isHeadend" class="form-row">
                    <div class="form-group form-group-sm row col-24 col-lg-12">
                      <label class="col-form-label col-24 col-lg-8">Arrival Date: </label>
                      <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                        <dx-date-box type="date"
                                     [acceptCustomValue]="false"
                                     displayFormat="MM/dd/yyyy"
                                     width="100%"
                                     [useMaskBehavior]="true"
                                     formControlName="arrivalDate"
                                     (onValueChanged)="setArrivalDate()">
                        </dx-date-box>
                      </div>
                    </div>
                    <div class="form-group form-group-sm row col-24 col-lg-12">
                      <label class="col-form-label col-24 col-lg-8">Pre-Staging Engineer: </label>
                      <div class="col-24 col-lg-16 col-xl-12 pl-0 pl-lg-3">
                        <div class="input-group">
                          <input type="text" class="form-control form-control-sm" formControlName="preStagingEngineer" />
                          <button class="btn btn-sm btn-primary" type="button" (click)="preStagingEngineerSearch()" [disabled]="!editMode">
                            <i class="fa fa-search fa-1x"></i>
                          </button>
                          <input type="hidden" class="form-control form-control-sm" formControlName="preStagingEngineerUserId" />
                          <!--<app-user-finder *ngIf="option.manualData.userFinderForPreStagingEngineerEmail?.isEnabled" id="pre-staging-engineer" [group]="form.controls.manualData" [option]="option.manualData.userFinderForPreStagingEngineerEmail"></app-user-finder>-->
                        </div>
                        <dx-data-grid *ngIf="hidePreStagingEngineerGrid" #grid id="grid" [dataSource]="preStagingEngineerGrid" keyExpr="userID"
                                      [rowAlternationEnabled]="true" [showBorders]="true"
                                      (onRowClick)="onPreStagingEngineerRowClick($event)">
                          <dxo-sorting mode="multiple"></dxo-sorting>
                          <dxo-paging [pageSize]="50"></dxo-paging>
                          <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[25, 50, 100]"></dxo-pager>
                          <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
                          <dxi-column dataField="userAdid" caption="ADID" dataType="string"></dxi-column>
                          <dxi-column dataField="displayName" caption="Display Name" dataType="string"></dxi-column>
                          <dxi-column dataField="email" caption="Email" dataType="string"></dxi-column>
                        </dx-data-grid>
                      </div>
                    </div>
                    <!--<div class="form-group form-group-sm row col-24 col-lg-12">
              <label class="col-form-label col-24 col-lg-8">Pre-Staging Engineer</label>
              <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                <input type="text" class="form-control form-control-sm" formControlName="preStagingEngineer" />
                *New User may only be selected by searching
              </div>
            </div>-->
                  </div>
                  <hr>
                  <div class="form-row">
                    <div class="form-group form-group-sm row col-24 col-lg-12">
                      <label class="col-form-label col-24 col-lg-8">Requested Activity Date: </label>
                      <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                        <input type="text" class="form-control form-control-sm" formControlName="activityDate" />
                      </div>
                    </div>
                    <div class="form-group form-group-sm row col-24 col-lg-12">
                      <label class="col-form-label col-24 col-lg-8">Last Update to Requested Activity Date & Time: </label>
                      <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                        <input type="text" class="form-control form-control-sm" formControlName="frbModifyDate" />
                      </div>
                    </div>
                  </div>

                  <div class="form-row">
                    <div class="form-group form-group-sm row col-24 col-lg-12">
                      <label class="col-form-label col-24 col-lg-8">Requested Activity Time Block: </label>
                      <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                        <input type="text" class="form-control form-control-sm" formControlName="timeBlock" />
                      </div>
                    </div>
                    <div class="form-group form-group-sm row col-24 col-lg-12">
                      <label class="col-form-label col-24 col-lg-8">Meeting SLA: </label>
                      <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                        <input type="text" class="form-control form-control-sm" formControlName="meetingSla" />
                      </div>
                    </div>
                  </div>
                  <hr>
                  <div class="form-row">
                    <div class="form-group form-group-sm row col-24 col-lg-12">
                      <label class="col-form-label col-24 col-lg-8">Fedline Activator WorkFlow Status: </label>
                      <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                        <dx-select-box [items]="activatorWFStatusList"
                                       displayExpr="endEventStus.eventStusDes"
                                       valueExpr="endEventStus.eventStusId"
                                       (onValueChanged)="activatorWFStatusChanged($event)"
                                       formControlName="activatorWFStatus"></dx-select-box>

                        <input type="hidden" class="form-control form-control-sm" formControlName="hdnActivatorWFStatus" />
                      </div>
                    </div>
                    <div class="form-group form-group-sm row col-24 col-lg-12" *ngIf="getFormControlValue('manualData.activatorWFStatus') == 3">
                      <label class="col-form-label col-24 col-lg-8">Activator Fail Codes: </label>
                      <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                        <dx-select-box [items]="activatorFailCodesList"
                                       displayExpr="failCdDes"
                                       valueExpr="failCdId"
                                       (onValueChanged)="getActivatorFailCodes($event)"
                                       formControlName="activatorFailCodes"></dx-select-box>

                        <input type="hidden" class="form-control form-control-sm" formControlName="hdnActivatorFailCodes" />
                      </div>
                    </div>
                  </div>

                  <div class="form-row">
                    <div *ngIf="!isDisconnect && (getFormControlValue('manualData.activatorWFStatus') == null || getFormControlValue('manualData.activatorWFStatus') == 6)" class="form-group form-group-sm row col-24 col-lg-12">
                      <label class="col-form-label col-24 col-lg-8">Production Tunnel Status: </label>
                      <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                        <dx-select-box [items]="producationTunnelStatusList"
                                       displayExpr="tunnelStatusDes"
                                       valueExpr="tunnelStatusID"
                                       formControlName="producationTunnelStatus"></dx-select-box>
                      </div>
                    </div>
                    <div class="form-group form-group-sm row col-24 col-lg-12">
                      <label class="col-form-label col-24 col-lg-8">MNS Activator: </label>
                      <div class="col-24 col-lg-16 col-xl-12 pl-0 pl-lg-3">
                        <div class="input-group">
                          <input type="text" class="form-control form-control-sm" formControlName="mnsActivator" />
                          <button class="btn btn-sm btn-primary" type="button" (click)="mnsActivatorSearch()" [disabled]="!editMode">
                            <i class="fa fa-search fa-1x"></i>
                          </button>
                          <input type="hidden" class="form-control form-control-sm" formControlName="mnsActivatorUserId" />
                          <!--<app-user-finder *ngIf="option.manualData.userFinderForMnsActivatorEmail?.isEnabled" id="mns-activator" [group]="form.controls.manualData" [option]="option.manualData.userFinderForMnsActivatorEmail"></app-user-finder>-->
                        </div>
                        <dx-data-grid *ngIf="hideMnsActivatorGrid" #grid id="grid" [dataSource]="mnsActivatorGrid" keyExpr="userID"
                                      [rowAlternationEnabled]="true" [showBorders]="true"
                                      (onRowClick)="onMnsActivatorRowClick($event)">
                          <dxo-sorting mode="multiple"></dxo-sorting>
                          <dxo-paging [pageSize]="50"></dxo-paging>
                          <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[25, 50, 100]"></dxo-pager>
                          <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
                          <dxi-column dataField="userAdid" caption="ADID" dataType="string"></dxi-column>
                          <dxi-column dataField="displayName" caption="Display Name" dataType="string"></dxi-column>
                          <dxi-column dataField="email" caption="Email" dataType="string"></dxi-column>
                        </dx-data-grid>
                      </div>
                    </div>
                  </div>
                </div>
              </mat-expansion-panel>
            </mat-accordion>
          </div>

          <div *ngIf="!isDisconnect" class="card mb-3">
            <mat-accordion>
              <mat-expansion-panel [expanded]="true">
                <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                  <mat-panel-title><h6>Event Requested Activity History</h6></mat-panel-title>
                </mat-expansion-panel-header>
                <div class="mb-3">
                  <dx-data-grid #grid id="grid" [dataSource]="fedlineCCDHist" [wordWrapEnabled]="true"
                                [rowAlternationEnabled]="true" [showBorders]="true" [columnAutoWidth]="true"
                                (onToolbarPreparing)="onToolbarPreparing($event)"
                                (onExporting)="onExporting($event)">
                    <dxo-sorting mode="multiple"></dxo-sorting>
                    <dxo-paging [pageSize]="50"></dxo-paging>
                    <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]"></dxo-pager>
                    <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
                    <dxi-column dataField="oldDt" caption="Old Activity Date" dataType="datetime"></dxi-column>
                    <dxi-column dataField="newDt" caption="New Activity Date" dataType="datetime"></dxi-column>
                    <dxi-column dataField="failCdDes" caption="Fail Reason Desc." dataType="string"></dxi-column>
                    <dxi-column dataField="rspbPartyNme" caption="Responsible Party" dataType="string"></dxi-column>
                    <dxi-column dataField="creatDt" caption="Reschedule Received Date" dataType="datetime"></dxi-column>
                    <div *dxTemplate="let data of 'exportTemplate'">
                      <button type="button" class="btn btn-sm btn-primary"
                              (click)="grid.instance.exportToExcel(false)">
                        Export to Excel
                      </button>
                    </div>
                  </dx-data-grid>
                </div>
              </mat-expansion-panel>
            </mat-accordion>
          </div>

          <app-event-history-template *ngIf="eventId > 0 && (isMNSPreConfigEng || isMDSPM || isMNSActivator)"
                                      [id]="eventId" [accordion]="true"></app-event-history-template>

          <div class="card mb-3">
            <mat-accordion>
              <mat-expansion-panel [expanded]="true">
                <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                  <mat-panel-title><h6>Event Update History</h6></mat-panel-title>
                </mat-expansion-panel-header>
                <div class="mb-3">
                  <dx-data-grid #grid1 id="grid1" [dataSource]="eventUpdateHistory" [wordWrapEnabled]="true"
                                [rowAlternationEnabled]="true" [showBorders]="true" [columnAutoWidth]="true"
                                (onToolbarPreparing)="onToolbarUpdatePreparing($event)"
                                (onExporting)="onExportingUpdate($event)">
                    <dxo-sorting mode="multiple"></dxo-sorting>
                    <dxo-paging [pageSize]="50"></dxo-paging>
                    <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]"></dxo-pager>
                    <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
                    <dxi-column dataField="mdsEventId" caption="Event ID" dataType="string"></dxi-column>
                    <dxi-column dataField="chngTypeNme" caption="Changes" dataType="string"></dxi-column>
                    <dxi-column dataField="fullNme" caption="Performed By" dataType="string"></dxi-column>
                    <dxi-column dataField="creatDt" caption="Date and Time" dataType="datetime"></dxi-column>
                    <div *dxTemplate="let data of 'exportTemplate'">
                      <button type="button" class="btn btn-sm btn-primary"
                              (click)="grid1.instance.exportToExcel(false)">
                        Export to Excel
                      </button>
                    </div>
                  </dx-data-grid>
                </div>
              </mat-expansion-panel>
            </mat-accordion>
          </div>
        </fieldset>
        <br />
        <div class="form-row text-center">
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4 offset-md-6 offset-lg-8">
            <button type="button" class="btn btn-sm btn-secondary btn-block" (click)="cancel()">
              Cancel
            </button>
          </div>
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4" *ngIf="!isLocked && allowEdit">
            <div *ngIf="editMode; then saveTemplate; else editTemplate;"></div>
            <ng-template #editTemplate>
              <button type="button" class="btn btn-sm btn-primary btn-block" (click)="edit()">
                Edit Event
              </button>
            </ng-template>
            <ng-template #saveTemplate>
              <button type="button" class="btn btn-sm btn-primary btn-block" (click)="save()" [disabled]="form.invalid">
                Save
              </button>
            </ng-template>
          </div>
        </div>
      </form>
    </div>
  </div>
</div>

